@echo off
setlocal EnableDelayedExpansion

rem Show and navigate the menu created by MakeCmdHelp.bat
rem Antonio Perez Ayala

rem Load the menu definition data from CmdHelp.txt file
cd "%~P0"
if not exist CmdHelp.txt (
   echo File not found: CmdHelp.txt. To create it, run:  MakeCmdHelp.bat
   goto :EOF
)
for /F "delims=" %%a in (CmdHelp.txt) do set "%%a"

rem Define the keys/values used to navigate the menu
set /A TabKey=9, EnterKey=13, F1=368, Alt_F4=240,  WM_VSCROLL=277
set /A HomeKey=292, PageUp=289, UpArrow=294, DownArrow=296, PageDown=290, EndKey=291
set /A SB_TOP=6, SB_PAGEUP=2, SB_LINEUP=0, SB_LINEDOWN=1, SB_PAGEDOWN=3, SB_BOTTOM=7
set /A scrl[2]=SB_TOP, scrl[3]=SB_PAGEUP, scrl[4]=SB_LINEUP, scrl[5]=SB_LINEDOWN, scrl[6]=SB_PAGEDOWN, scrl[7]=SB_BOTTOM

rem Initialize the screen and activate the menu
set "cols=" & set "lines="
for /F "skip=2 tokens=2" %%a in ('mode con') do (
   if not defined lines (set "lines=%%a"
   ) else if not defined cols set "cols=%%a"
)
title WINDOWS  CMD.EXE  COMMANDS  HELP
color 1F
set "back="
set "page=0"

:nextPage
set "help="
set "run="
mode con cols=80 lines=!last[%page%]!
(
cls
echo/
echo/
echo         W I N D O W S     C M D . E X E     C O M M A N D S     H E L P
echo/
echo/
)
if %page% equ 0 (          rem Initial menu
   for /L %%i in (1,1,9) do echo !head[0%%i]!
) else (
   echo !head[%page:~0,2%]!
   echo/
   echo/
   if "%page:~2%" equ "" ( rem Level 1 submenu
      for /L %%i in (1,1,19) do if defined head[%page:~0,2%%%i] echo !head[%page:~0,2%%%i]!
   ) else (                rem Level 2 submenu
      set "help=!help[%page%]!"
      echo !head[%page%]!
      echo/
      if "!head[%page%]:~3,6!" neq "Tables" (
         set "run=!head[%page%]:~3,12!"
      ) else (
         set "run=SET /A      "
      )
      ColorChar "-> !run!" /F1 "Click here to enter parameters and run this command" 32x13 13 10
      echo/
      )
   )
)
%help%
CursorPos 77 0 & ColorChar /CF " x "
if defined back (set "/BF=/1F") else set "/BF=/18"
CursorPos 0 0 & ColorChar %/BF% "<--" /F9 " ? " 13
set "K=" & set "M="
if defined run (
    rem     1           2         3        4         5           6          7
    set "K=%TabKey%    %HomeKey% %PageUp% %UpArrow% %DownArrow% %PageDown% %EndKey%"
    set "M=15 10 79 10"
)
:getInput
REM          -2         -1   0       (see above)               Back=-2  Help=-1  Close=0
GetInput /I %EnterKey% %F1% %Alt_F4% %K% "!keys[%page%]!"  /M  0 0 2 0  3 0 5 0  77 0 79 0  !mous[%page%]! %M%
set /A "option=%errorlevel%-3"
if %option% gtr 0 (
   if not defined run (        rem Submenu page
      set "back=%page% %back%"
      set "page=%page%%option%"
      goto nextPage
   ) else if %option% equ 1 (  rem TabKey = Run example
      CursorPos 15 10 & ColorChar /F1 32x51 & CursorPos 15 10
      set "param="
      set /P "param="
      set "cmd=!run!"
      if "!cmd:~0,5!" equ "ECHO " set "cmd=ECHO"
      (
      echo @prompt=$S$H
      echo !cmd! !param!
      echo @echo/^&pause^&exit /B
      ) > run.bat
      start "!cmd! !param!" cmd /C run.bat
      CursorPos 15 10 & ColorChar /F1 "Click here to enter parameters and run this command" & CursorPos 0 0
      goto getInput
   ) else (                    rem Cursor control key: Scroll screen
      SendMessage %WM_VSCROLL% !scrl[%option%]!
      goto getInput
   )
) else if %option% equ -2 (    rem Enter = Back
   if not defined back ( goto getInput
   ) else (
      for /F "tokens=1*" %%a in ("%back%") do (
         set "page=%%a"
         set "back=%%b"
      )
      goto nextPage
   )
) else if %option% equ -1 (    rem F1 = Help
   start "CmdHelp - Help" cmd /C color F0 ^& mode con cols=80 lines=16 ^& type CmdHelpF1.txt ^& pause
   goto getInput
)
rem else  %option% equ 0       rem Alt_F4 = Close
del run.bat 2>NUL
mode con cols=%cols% lines=%lines%
color
cls
